"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ColorTokens = void 0;
const tslib_1 = require("tslib");
const React = require("react");
const util_1 = require("./util");
const { createElement: h } = React;
const astToReact = (ast, code, pos, as, rest = {}) => {
    if (typeof ast === "number")
        return [code.slice(pos, pos + ast), ast];
    const [types, tokens, language] = ast;
    const children = [];
    const length = tokens.length;
    let nodeTextLength = 0;
    for (let i = 0; i < length; i++) {
        const token = tokens[i];
        const [node, len] = astToReact(token, code, pos + nodeTextLength, "span");
        nodeTextLength += len;
        children.push(node);
    }
    const props = {
        className: "token " + types.join(" "),
        "data-lang": language,
    };
    return [
        h(as, Object.assign(Object.assign(Object.assign({}, props), rest), { className: props.className + (rest.className ? " " + rest.className : "") }), ...children),
        nodeTextLength,
    ];
};
const ColorTokens = (_a) => {
    var { code, lang, prefix = "code-colors", as = "code" } = _a, rest = tslib_1.__rest(_a, ["code", "lang", "prefix", "as"]);
    const [node, setNode] = React.useState(null);
    const Tag = as;
    React.useEffect(() => {
        setNode(null);
        let unmounted = false;
        (0, util_1.tokens)(code, lang)
            .then((ast) => {
            if (!unmounted) {
                const [node] = astToReact(ast, code, 0, Tag, rest);
                setNode(node);
            }
        })
            .catch((err) => { });
        return () => {
            unmounted = true;
        };
    }, [code]);
    return node || React.createElement(Tag, Object.assign({}, rest), code);
};
exports.ColorTokens = ColorTokens;
//# sourceMappingURL=ColorTokens.js.map